﻿using System;
using UnityEngine;

namespace Mod
{
public class EMP4 : MonoBehaviour
   {TrailRenderer CFM;float speed = 10f;float frequency = 300f;float magnitude = 350f;float damage = 100000000000000f;float ImpactStrength = 5f;bool closing;Vector3 pos;LayerMask layers;public bool createHitDecal = true;public bool SpawnExplosionEffect = true;
void Awake(){CFM = gameObject.AddComponent<TrailRenderer>();CFM.time = 0.26f;CFM.startWidth = 0.2f;CFM.material = ModAPI.FindMaterial("VeryBright").ShallowClone();CFM.startColor = new Color(UnityEngine.Random.value, UnityEngine.Random.value, UnityEngine.Random.value, 300);CFM.endColor = new Color(UnityEngine.Random.value, UnityEngine.Random.value, UnityEngine.Random.value, 300);
CFM.numCapVertices = 2;layers = LayerMask.GetMask("Objects", "Bounds", "Debris");gameObject.SetLayer(9);}
      void Update()
        {
            if (closing)
            {
                CFM.autodestruct = true;
                return;
            }
            pos = transform.position;
            var dir = transform.right;
            var distance = speed * Time.deltaTime;

            var ray = Utils.MaterialAwareRaycast(pos, dir, distance, layers, 16);

            if (ray.hit.HasValue)
            {
                var hit = ray.hit.Value;
                var hitPhys = ray.physicalBehaviour;

                if (hitPhys && hitPhys.ReflectsLasers)
                {
                    hitPhys.rigidbody.AddForceAtPosition(hit.normal * -ImpactStrength, hit.point, ForceMode2D.Impulse);
                    var newDir = Vector2.Reflect(transform.right, hit.normal);
                    transform.position = hit.point;
                    transform.right = newDir;
                    return;
                }

                if (hitPhys && hitPhys.AbsorbsLasers)
                {
                    transform.position = hit.point;
                    hit.collider.attachedRigidbody.AddForceAtPosition(hit.normal * -ImpactStrength, hit.point);
                    Impact(hit);
                    return;
                }
            }
            else
            {
                pos += dir * Time.deltaTime * speed;
                transform.position = pos + transform.up * Time.deltaTime * Mathf.Sin(Time.time * frequency) * magnitude;
            }
        }

        private void Impact(RaycastHit2D hit)
        {
            Vector2 normal = hit.normal;
            this.closing = true;

            float dir = Mathf.Atan2(normal.y, normal.x);
            {
            }

            var physicalBehaviour = hit.collider.GetComponent<PhysicalBehaviour>();

            if (Global.main.PhysicalObjectsInWorldByTransform.TryGetValue(hit.transform, out physicalBehaviour) && physicalBehaviour.SimulateTemperature)
            {
            }

            ExplosionCreator.CreatePulseExplosion(hit.point, ImpactStrength, 5000f, SpawnExplosionEffect, true);
        }
    }
}