﻿using UnityEngine;

public struct Cyborg
{
    public static AudioClip SpartanLaserCharge;
    public static AudioClip SpartanLaserFire;
    public static AudioClip SpartanLaserExit;

    public static AudioClip EnergySwordHum;
    public static AudioClip[] Hungry;
    public static AudioClip EnergySwordIgnite;
    public static AudioClip EnergySwordOff;
    public static AudioClip[] EnergySwordHits;
    public static AudioClip[] PlasmaPistolFire;
    public static AudioClip[] PlasmaRifleFire;
    public static AudioClip[] NeedleFire;
    public static AudioClip[] NeedleExplode;
    public static AudioClip PlasmaRifleOverheat;
    public static AudioClip PlasmaPistolChargeStart;
    public static AudioClip PlasmaPistolLoop;
    public static AudioClip PlasmaPistolChargedShot;

    public static Sprite Needle;
    public static Sprite Needle2;

    public static void Initialise()
    {

        SpartanLaserCharge = ModAPI.LoadSound("sfx/spartan_laser_charge.wav");
        SpartanLaserFire = ModAPI.LoadSound("sfx/spartan_laser_fire.wav");
        SpartanLaserExit = ModAPI.LoadSound("sfx/spartan_laser_exit.wav");

        EnergySwordHum = ModAPI.LoadSound("Looping.wav");

        Hungry = new[]{
            ModAPI.LoadSound("dubgun2.wav"),
            ModAPI.LoadSound("dubgun.wav"),
        };

        EnergySwordIgnite = ModAPI.LoadSound("on.wav");
        EnergySwordOff = ModAPI.LoadSound("on.wav");


        PlasmaRifleOverheat = ModAPI.LoadSound("sfx/plasma_rifle_overheat.wav");

        PlasmaPistolChargeStart = ModAPI.LoadSound("sfx/plasma_pistol_start.wav");
        PlasmaPistolLoop = ModAPI.LoadSound("sfx/plasma_pistol_loop.wav");
        PlasmaPistolChargedShot = ModAPI.LoadSound("sfx/plasma_pistol_charged.wav");

        EnergySwordHits = new[]{
            ModAPI.LoadSound("sfx/energy_sword_impact1.wav"),
            ModAPI.LoadSound("sfx/energy_sword_impact2.wav"),
            ModAPI.LoadSound("sfx/energy_sword_impact3.wav"),
            ModAPI.LoadSound("sfx/energy_sword_impact4.wav"),
        };

        PlasmaPistolFire = new[]{
            ModAPI.LoadSound("sfx/plasma_pistol1.wav"),
            ModAPI.LoadSound("sfx/plasma_pistol2.wav"),
            ModAPI.LoadSound("sfx/plasma_pistol3.wav"),
        };

        PlasmaRifleFire = new[]{
            ModAPI.LoadSound("sfx/plasma_rifle1.wav"),
            ModAPI.LoadSound("sfx/plasma_rifle2.wav"),
            ModAPI.LoadSound("sfx/plasma_rifle3.wav"),
        };

        NeedleFire = new[]{
            ModAPI.LoadSound("sfx/needler_fire1.wav"),
            ModAPI.LoadSound("sfx/needler_fire2.wav"),
            ModAPI.LoadSound("sfx/needler_fire3.wav"),
        };

        NeedleExplode = new[]{
            ModAPI.LoadSound("sfx/needle_explode1.wav"),
            ModAPI.LoadSound("sfx/needle_explode2.wav"),
            ModAPI.LoadSound("sfx/needle_explode3.wav"),
        };
        Needle = ModAPI.LoadSprite("Proj.png");
        Needle = ModAPI.LoadSprite("lame.png");
    }
}
